
//xsetaseta@gmail.com
//comSeta prueba
//Lector de sensor de temperatura externa
//16/04/2018


#include <avr/io.h>
#include <avr/interrupt.h>

#define IN_READ 2

unsigned long time,timeU,timeInicio,diferencia;
bool inicio;
int dato;
bool estadoDato;

byte canal;
int grados;
int datosExtras;

unsigned long DatoSalida;
char NumBit;

void setup(void)
{
  Serial.begin(9600);
  Serial.println("Int433");
  pinMode(2, INPUT);
  pinMode(IN_READ, INPUT);

  cli();                // Disable INT
  EIMSK |= (1 << INT0);  // Enable external interrupt INT0
  EICRA |= (1 << ISC01); // Trigger INT0 on Change  en bajada
  sei();
}


void loop(void)
{
 if(estadoDato==1)
   {
     estadoDato=0;
     if(dato==255)
       {   inicio=0; NumBit=0; goto salto2;    }    //error tiempo max
       
     if(dato==3)   //inicio o fin de dato
       {         
         if(inicio==0) 
           {
             inicio=1;
           }
           else
           {
            DatoSalida|=0x80000000;
            canal=(DatoSalida & 0x0000000C) >> 2;
            grados=(DatoSalida >>4 ) & 0xFFF;
            if(grados & 2048) grados |=0xF000;  //negativos
            datosExtras=(DatoSalida >>24 ) & 0x7F;
            Serial.print("Canal,"); Serial.print(canal); 
            Serial.print(",Grados,"); Serial.print(grados); 
            Serial.print(",Extra,"); Serial.println(datosExtras);
            NumBit=0;
            DatoSalida=0;
           }
         
         goto salto2;
       }
       
     if(inicio==1)
       {
         DatoSalida<<=1;
         if(dato==1) DatoSalida|=1;     
       } 
salto2:
    ;
   }

}


ISR(INT0_vect)
{
  time=micros();       //  10004  2436  5004  5000  2440  5000  
  diferencia=time-timeU;
  if (diferencia>2200 && diferencia<10200)
        {
          if(diferencia>2300 && diferencia<2600)  //0
            {
              estadoDato=1; dato=0;
              goto salto;
            }
          if(diferencia>4950 && diferencia<5050)  //1
            {             
              estadoDato=1; dato=1;
              goto salto;
            }
          if(diferencia>9950 && diferencia<10050)  //empieza
            {
             estadoDato=1; dato=3;
             goto salto;
            }
        }
        else
        {
         estadoDato=1; dato=255; 
        }
 salto: 
    timeU=time; 
}

